' update table :
' date   by  file:               comment:
' 990715 JK  math.inc            creation


'--------------------------------------------------
' Description : 
'     file for universal mathematic functions 
'--------------------------------------------------


'--------------------------------------------------
FUNCTION mag(real_part, img_part) AS FLOAT

    ' returns the magnitude of a Complex number

    DIM r_squared	 AS FLOAT ' real part squared
    DIM i_squared	 AS FLOAT ' img. part squared

	'                          rule of Phytagoras
    r_squared = real_part * real_part  
    i_squared = img_part  * img_part   
    mag = SQRT(r_squared + i_squared)   

ENDFUNCTION

'--------------------------------------------------
FUNCTION mag2(real_part, img_part) AS FLOAT

    ' returns the magnitude of a Complex number
	
	'  this is just the same function as mag()
	'  we just need a second name for it because 
	'  otherwise we get errors if we include mag()
	'  into a library twice.

    DIM r_squared	 AS FLOAT ' real part squared
    DIM i_squared	 AS FLOAT ' img. part squared

	'                          rule of Phytagoras
    r_squared = real_part * real_part  
    i_squared = img_part  * img_part   
    mag2 = SQRT(r_squared + i_squared)   

ENDFUNCTION

'--------------------------------------------------
FUNCTION phase(real_part, img_part) AS FLOAT

    ' returns the phase of a Complex number
	'  return value is in radians (deutsch : Bogenma)

    DIM value1, arctan_value   AS FLOAT	
	
	value1       = img_part / real_part
	arctan_value = ARCTAN(value1)	
	
	IF (real_part < 0) THEN 
		IF (arctan_value <= 0 ) THEN
		    phase = arctan_value + 3.141592654
		ELSE
		    phase = arctan_value - 3.141592654
	    ENDIF
	ELSE
	    phase  =    arctan_value
	ENDIF
	
ENDFUNCTION
