****************************************
*	 Prozenummer = 1
*	 Delay = 1000
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 4000001
*	 ATSRAM = 0
*	 OPT_LEVEL = 0
*	 SAVECOMPIL = 0
****************************************
'###############################################################
'#             Test-Programm for ADwin-Pro-CNT-VR4-L           #
'###############################################################
' updates:
' 20.02.2004 JK for CLK&DIR mode (with Software-Latch)

' Remark: 
' The following information may not be present in old documetation :

' If the mode is set to CLK&DIR , the CLK is NOT connected to 
' the connector, but to an internal 5 MHZ signal. Also, DIR is 
' fixed, so that the counter is always upcounting.
' Then it is for example possible to measure the time distance
' between two executions of the CNT_LATCH() commands.
' In this example, we get values of 125 in cnt_1, cnt_2, ... .
' 125 * 200 ns = 25000 ns = 25 s = the setting of GLOBALDELAY.
' However, such simple measurements could be done also just by 
' using READ_TIMER().
' But the following application might be reasonable :
'      Counter 1 in A/B mode
'      Counter 2 in CLK&DIR mode
'      Executing 	CNT_LATCH() on both counters 
'      Result : counter 1 gives a number of counts and counter 2 
'               gives an accurate time , which corresponds to 
'               the number of counter 1

#INCLUDE adwinpro.inc
#INCLUDE adwpdio.inc
#DEFINE cnt_1 PAR_1
#DEFINE cnt_2 PAR_2
#DEFINE cnt_3 PAR_3
#DEFINE cnt_4 PAR_4
#DEFINE card PAR_9
DIM val_1, val_2, val_3, val_4 AS INTEGER
DIM val_1o, val_2o, val_3o, val_4o AS INTEGER
INIT: '#########################################################
  GLOBALDELAY = 1000				' 25 s delay   (ADSP processor)
  card=1					'set card-address to 1
	CNT_ENABLE(card,0)
  CNT_SETMODE(card,15)			' 15=CLK&DIR , 0=A/B 
  CNT_CLEAR(card,1111b)			'clear all counters
  CNT_ENABLE(card,1111b)		'activate all counters
'  EXTLCH_ENABLE(card,15)		'enable all external latches
  EXTLCH_ENABLE(card,0)			'disable all external latches
EVENT: '########################################################
	CNT_LATCH(card,15)			'latch all counters (latch done by software command)
  val_1=CNT_READLATCH32(card,1)	'read latch counter #1
  val_2=CNT_READLATCH32(card,2)	'read latch counter #2
  val_3=CNT_READLATCH32(card,3)	'read latch counter #3
  val_4=CNT_READLATCH32(card,4)	'read latch counter #4
  cnt_1=val_1-val_1o			'calc. diff. counter #1
  cnt_2=val_2-val_2o			'calc. diff. counter #2
  cnt_3=val_3-val_3o			'calc. diff. counter #3
  cnt_4=val_4-val_4o			'calc. diff. counter #4
  val_1o=val_1				'old value = new value
  val_2o=val_2				'...
  val_3o=val_3				'...
  val_4o=val_4				'...
'  IF (CHECKLED(card,DIO)=0) THEN	'LED turned off?
'    SETLED(card,DIO,1)			'turn on LED
'  ELSE
'    SETLED(card,DIO,0)			'turn off LED
'  ENDIF
FINISH: '#######################################################
	CNT_ENABLE(card,0)
'###############################################################